# TFTP Proxy server

## Overview

This script is TFTP proxy that works with PowerShell7.

A user can send and receive a file by using TFTP 
when there are two hosts that cannot communicate directly.

And also it supports RRQ and WRQ as specified in RFC1350.


## Example of network configuration 

<pre>
[HostA]               [TFTP Proxy]                    [HostB]
10.0.0.1 <------> 10.0.0.2    192.168.1.2 <------>  192.168.1.1
fileA.bin                                           fileB.bin
</pre>


* Example of downloading a file from HostB to HostA

tftp.exe -i 10.0.0.2 get fileB.bin

* Example of uploading a file from HostA to HostB

tftp.exe -i 10.0.0.2 put fileA.bin


## Supported Tool

Microsoft Windows 10 and 11

PowerShell 7

*NOTE*

Not supported Windows PowerShell 5.1

## Usage

### SYNOPSIS

TFTP Proxy

### DESCRIPTION

This script is TFTP proxy that works with PowerShell7.

Ana also it supports RRQ and WRQ as specified in RFC1350.

### PARAMETER ListenIPAddress

Listen IP address 

### PARAMETER ListenPort

Listen Port number 

### PARAMETER TFTPServerIPAddress

TFTP server IP address (Mandatory)

### PARAMETER TFTPServerPort

TFTP server Port number

### PARAMETER TimeoutValue

Session timeout (seconds)

### PARAMETER LogVerbose

Verbose mode for Debug

### PARAMETER Progress

Show a progress however script will slow down.

### EXAMPLE

.\udp_proxy.ps1 -TFTPServerIPAddress 192.168.1.1

.\udp_proxy.ps1 -TFTPServerIPAddress 192.168.1.1 -Progress

.\udp_proxy.ps1 -ListenIPAddress 10.0.0.1 -ListenPort 69 -TFTPServerIPAddress 192.168.1.1 -TFTPServerPort 69 -TimeoutValue 5 -LogVerbose -Progress

## History

*01/06/2025 Ver1.0*
- First release


## License

MIT

[LICENSE](LICENSE)

## Author

(C) 2025 Yutaka Hirata(YOULAB)

https://yutakasan.11ya.net/

https://crowdworks.jp/public/employees/2224566

